---
- hosts: all
  become: yes
  tasks:

    - name: Install Netstat to get port list
      package:
        name: net-tools
        state: present

    - name: Gather the package facts
      ansible.builtin.package_facts:
        manager: auto

    - name: Gather facts on listening ports
      listen_ports_facts:

    - name: Save services to fact
      set_fact:
        running_services: >-
          'Running':
            {% for listening in (ansible_facts.tcp_listen + ansible_facts.udp_listen) %}{% if listening.address == '0.0.0.0' %}
            {{ listening.name | default ("unknown") }}:
              - transport: {{ listening.protocol }}
                ports: {{listening.port}}
            {% endif %}{% endfor %}
    - debug:
        var: running_services

    - name: Create CDEF
      oscal_cdef:
        title: 'AMI'
        type: 'Image'
        packages: "{{packages}}"
        controls: "{{controls}}"
        services: "{{services |combine(running_services | from_yaml) }}"
      delegate_to: 127.0.0.1
      register: result

    - name: Write cdef to local file
      local_action: copy content="{{result.output}}" dest=../generated/ami_cdef.xml

    - name: save tf variables
      template:
        src: templates/variables.j2
        dest: ami.tfvars
    
    - name: Fetch terraform template
      fetch:
        src: ami.tfvars
        dest: ../ami.tfvars
        flat: yes